<?php
/*
 * Migrations generated by: Skipper (http://www.skipper18.com)
 * Migration id: 80c6ac85-de61-4ef0-8692-1e2a68cd272d
 * Migration datetime: 2020-08-24 11:35:39.843473
 */

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class SkipperMigrations2020082411353984 extends Migration
{
/**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::dropIfExists('prelevement_cervico_vaginals');
        Schema::dropIfExists('recherche_mycosplasmes');
        Schema::dropIfExists('hemocultures');
        Schema::dropIfExists('prelevement_uretral_results');
        Schema::dropIfExists('spermogrammes');
        Schema::dropIfExists('antibiogramme_result');
        Schema::dropIfExists('antibiotiques');
        Schema::dropIfExists('antibiogrammes');
        Schema::dropIfExists('result_types');
        Schema::dropIfExists('exam_types');
        Schema::dropIfExists('insurance_to_patient');
        Schema::dropIfExists('numeric_results');
        Schema::dropIfExists('pn_results');
        Schema::dropIfExists('alpha_numeric_results');
        Schema::dropIfExists('exam_price_by_insurance');
        Schema::dropIfExists('qualifications');
        Schema::dropIfExists('tests');
        Schema::dropIfExists('hospitals');
        Schema::dropIfExists('exams');
        Schema::dropIfExists('demands');
        Schema::dropIfExists('insurances');
        Schema::dropIfExists('patients');

        Schema::create('patients', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->string('lastname');
            $table->string('firstname')->nullable(true);
            $table->date('birthdate');
            $table->string('phone_number')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->timestamp('created_at')->nullable(true);
            $table->bigInteger('user_id')->nullable(true)->unsigned();
            $table->enum('gender', ["f","m"])->nullable(true);
        });
        Schema::create('insurances', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->string('name')->nullable(true);
            $table->string('acronym');
        });
        Schema::create('demands', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->string('file_number');
            $table->string('name_physician')->nullable(false);
            $table->string('hospital')->nullable(true);
            $table->bigInteger('patient_id')->nullable(true)->unsigned();
            $table->bigInteger('user_id')->nullable(true)->unsigned();
            $table->bigInteger('insurance_id')->nullable(true)->unsigned();
            $table->enum('status', ["Enregistré","En cours","Traité","Annulé"])->nullable(true);

            $table->string('order_number_physician')->nullable(true);
            $table->bigInteger('qualification_id')->nullable(true)->unsigned();
            $table->timestamp('updated_at')->nullable(true);
            $table->timestamp('created_at')->nullable(true);
        });
        Schema::create('exams', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->string('name')->nullable(true);
            $table->string('norme')->nullable(true);
            $table->float('base_price', 8, 2)->nullable(true);
            $table->bigInteger('user_id')->nullable(true)->unsigned();
            $table->bigInteger('result_type_id')->nullable(true)->unsigned();
            $table->bigInteger('exam_type_id')->nullable(true)->unsigned();
        });



        Schema::create('tests', function (Blueprint $table) {
            $table->bigInteger('resultat_id')->nullable(true)->unsigned();
            $table->string('resultat_type')->nullable(true);
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->bigInteger('exam_id')->unsigned();
            $table->double('price');
            $table->bigInteger('demand_id')->unsigned();
            $table->bigInteger('insurance_id')->unsigned();
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
        });
        Schema::create('qualifications', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->string('label');
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
        });
        Schema::create('exam_price_by_insurance', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement();
            $table->bigInteger('exam_id')->unsigned();
            $table->bigInteger('insurance_id')->unsigned();
            $table->double('price', 8, 2)->default(0);
            $table->double('tm', 8, 2)->nullable(true);
            $table->double('gap_tm', 8, 2)->nullable(true);
            $table->double('gap', 8, 2)->nullable(true);
            $table->double('base_price', 8, 2);
        });
        Schema::create('alpha_numeric_results', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->string('value')->nullable(true);
        });
        Schema::create('pn_results', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->enum('value', ["POSITIF","NEGATIF"])->nullable(true);
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
        });
        Schema::create('numeric_results', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->string('unite')->nullable(true);
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->double('value', 8, 2)->nullable(true);
        });
        Schema::create('insurance_to_patient', function (Blueprint $table) {
            $table->bigInteger('patient_id')->unsigned();
            $table->bigInteger('insurance_id')->unsigned();
            $table->string('insurance_nr');
            $table->boolean('main_insured')->default(true);
            $table->string('main_insured_nr')->nullable(true);
            $table->string('main_insured_name')->nullable(true);
            $table->date('expiration_date')->nullable(true);
            $table->primary(['patient_id','insurance_id']);
        });
        Schema::create('exam_types', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->string('label')->unique();
            $table->timestamp('updated_at')->nullable(true);
            $table->timestamp('created_at')->nullable(true);
        });
        Schema::create('result_types', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->string('code')->unique();
            $table->string('label')->unique();
            $table->timestamp('updated_at')->nullable(true);
            $table->timestamp('created_at')->nullable(true);
        });
        Schema::create('antibiogrammes', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->string('germe')->nullable(true);
            $table->enum('methode', ["Diffusion sur gélose","ATB UR EU","ATB G-EU","ATB STAPH","VITEK 2"])->nullable(true);
            $table->string('methode_autre')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->timestamp('created_at')->nullable(true);
        });
        Schema::create('antibiotiques', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->string('code');
            $table->string('name');
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
        });
        Schema::create('antibiogramme_result', function (Blueprint $table) {
            $table->bigInteger('antibiotique_id')->unsigned();
            $table->bigInteger('antibiogramme_id')->unsigned();
            $table->enum('result', ["S","I","R"]);
            $table->primary(['antibiotique_id','antibiogramme_id']);
        });
        Schema::create('spermogrammes', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->string('ph')->nullable(true);
            $table->string('ph_norme')->nullable(true)->default('7.0-8.0');
            $table->string('volume_ejaculat')->nullable(true);
            $table->string('volume_ejaculat_unite')->nullable(true)->default('ml');
            $table->string('volume_ejaculat_norme')->nullable(true)->default('1.5-6.0ml');
            $table->string('agglutination_spontanee')->nullable(true);
            $table->string('leucocytes')->nullable(true);
            $table->string('leucocytes_normale')->nullable(true)->default('1000000/ml');
            $table->string('cellules_rondes')->nullable(true);
            $table->string('cellules_rondes_unite')->nullable(true)->default('% des spermatozoides');
            $table->string('cellules_rondes_normale')->nullable(true)->default('3%');
            $table->string('numeration')->nullable(true);
            $table->string('numeration_normale')->nullable(true)->default('20-200millions/ml');
            $table->string('numeration_unite')->nullable(true)->default('ml');
            $table->string('mobilite_apres_une_heure')->nullable(true);
            $table->string('mobilite_apres_une_heure_normale')->nullable(true)->default('>40');
            $table->string('mobilite_apres_une_quatre_heure')->nullable(true);
            $table->string('mobilite_apres_quatre_heure_normale')->nullable(true)->default('>40');
            $table->string('mobilite_unite')->nullable(true)->default('%');
            $table->string('vitalite')->nullable(true);
            $table->string('aspect')->nullable(true);
            $table->string('couleur')->nullable(true);
            $table->integer('spermocytogramme_nb_spermatozoide_normaux')->nullable(true);
            $table->integer('spermocytogramme_nb_spermatozoide_normaux_unite')->nullable(true);
            $table->integer('spermocytogramme_anomalie_tete')->nullable(true);
            $table->integer('spermocytogramme_macrocephalie')->nullable(true);
            $table->integer('spermocytogramme_effilee')->nullable(true);
            $table->integer('spermocytogramme_ronde')->nullable(true);
            $table->integer('spermocytogramme_piece_intermediaire')->nullable(true);
            $table->integer('spermocytogramme_reste_cytoplasme')->nullable(true);
            $table->integer('spermocytogramme_grele')->nullable(true);
            $table->integer('spermocytogramme_flagelle')->nullable(true);
            $table->integer('spermocytogramme_absent')->nullable(true);
            $table->integer('spermocytogramme_ecourte')->nullable(true);
            $table->integer('spermocytogramme_enroule')->nullable(true);
            $table->integer('spermocytogramme_angulaire')->nullable(true);
            $table->text('conclusion')->nullable(true);
            $table->string('biologiste')->nullable(true);
            $table->bigInteger('antibiogramme_id')->nullable(true)->unsigned();
        });
        Schema::create('prelevement_uretral_results', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->enum('macroscopique_aspect', ["purulent","transparent","sec","autre"])->nullable(true);
            $table->string('macroscopique_aspect_autre')->nullable(true);
            $table->enum('macroscopique_couleur', ["jaunatre","rougeatre","autre"])->nullable(true);
            $table->string('macroscopique_couleur_autre')->nullable(true);
            $table->string('microscopique_leucocytes')->nullable(true);
            $table->string('microscopique_hematies')->nullable(true);
            $table->string('microscopique_cellules')->nullable(true);
            $table->string('microscopique_autres')->nullable(true);
            $table->enum('microscopique_parasites', ["present","absence"])->nullable(true);
            $table->string('microscopique_preciser')->nullable(true);
            $table->enum('microscopique_levures', ["presence","absence"])->nullable(true);
            $table->enum('coloration_gram', ["diplocoque gram negatif","cocci gram positif en amas","cocci gram positif en chainette","bacille gram negatif","absence de germes","autres"])->nullable(true);
            $table->string('coloration_gram_autre')->nullable(true);
            $table->string('examen_apres_culture_coloration_gram')->nullable(true);
            $table->string('examen_apres_culture_germe_identifie')->nullable(true);
            $table->boolean('antibiogramme_effectue')->nullable(true);
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->bigInteger('antibiogramme_id')->nullable(true)->unsigned();
        });
        Schema::create('hemocultures', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->enum('aerobie', ["positive"," negative"])->nullable(true);
            $table->enum('enaerobie', ["positive","negative"])->nullable(true);
            $table->enum('coloration_gram', ["diplocoque gram negatif","diplocoque gram positif","cocci gram positif","bacille gram negatif","absence de germes"])->nullable(true);
            $table->enum('culuture', ["positive","négative"])->nullable(true);
            $table->boolean('antibiogramme_effectue')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->timestamp('created_at')->nullable(true);
            $table->bigInteger('antibiogramme_id')->nullable(true)->unsigned();
        });
        Schema::create('recherche_mycosplasmes', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->enum('prelevement', ["1e jet urinaire","Sperme","Prélèvement urétal","prélèvement vaginal"])->nullable(true);
            $table->enum('culture_ureaplasma', ["Positive","Negative"])->nullable(true);
            $table->enum('culture_mycoplasma', ["Positive","Negative"])->nullable(true);
            $table->string('culture_ureaplasma_titre')->nullable(true);
            $table->string('culture_mycoplasma_titre')->nullable(true);
            $table->enum('culture_ureaplasma_interpretation', ["Significatif","Non significatif"])->nullable(true)->unique();
            $table->enum('culture_mycoplasma_interpretation', ["Significatif","Non significatif"])->nullable(true);
            $table->text('culture_conclusion')->nullable(true);
            $table->enum('culture_antibiogramme', ["Effectué","Non effectué"])->nullable(true);
            $table->bigInteger('antibiogramme_id')->nullable(true)->unsigned();
        });
        Schema::create('prelevement_cervico_vaginals', function (Blueprint $table) {
            $table->bigInteger('id')->autoIncrement()->unsigned();
            $table->timestamp('created_at')->nullable(true);
            $table->timestamp('updated_at')->nullable(true);
            $table->enum('aspect_macroscopique', ["Pateux","Laiteux","Glaireux","Autre"])->nullable(true);
            $table->text('aspect_macroscopique_autre')->nullable(true);
            $table->enum('couleur_macroscopique', ["Chocolaté","Blanchâtre","Autre"])->nullable(true)->unique();
            $table->text('couleur_macroscopique_autre')->nullable(true);
            $table->string('ph_macroscopique')->nullable(true);
            $table->enum('test_potasse_macroscopique', ["Positif","Negatif"])->nullable(true);
            $table->text('leucocytes_microscopique')->nullable(true);
            $table->text('hematies_microscopique')->nullable(true);
            $table->text('cellules_microscopique')->nullable(true);
            $table->text('levures_microscopique')->nullable(true);
            $table->text('filaments_myceliens_microscopique')->nullable(true);
            $table->text('trichomonas_vaginalismicroscopique')->nullable(true);
            $table->text('microscopique_autre')->nullable(true);
            $table->enum('coloration_gram', ["Diplocoque Gram négatif","Bacille Gram négatif","Cocci Gram positifen amas","Absence de germes","Cocci Gram positif en chaiette","Mobilincus","Cocco Bacille Gram variable","CLUE CELLS"])->nullable(true);
            $table->string('coloration_bacille_doderlein')->nullable(true);
            $table->string('coloration_type_flore')->nullable(true);
            $table->text('coloration_gram_apres_culture')->nullable(true);
            $table->text('identificatio_bacteriologie_apres_culture')->nullable(true);
            $table->text('identificatio_mycologie_apres_culture')->nullable(true);
            $table->enum('antibiogramme_apres_culture', ["Effectué","Non effectué"])->nullable(true);
            $table->enum('antifongigramme_apres_culture', ["Effectué","Non effectué"])->nullable(true);
            $table->text('conclusion_apres_culutre')->nullable(true);
            $table->bigInteger('antibiogramme_id')->nullable(true)->unsigned();
        });
        Schema::table('demands', function (Blueprint $table) {
            $table->foreign('patient_id')->references('id')->on('patients');
        });
        Schema::table('demands', function (Blueprint $table) {
            $table->foreign('insurance_id')->references('id')->on('insurances');
        });

        Schema::table('demands', function (Blueprint $table) {
            $table->foreign('qualification_id')->references('id')->on('qualifications');
        });
        Schema::table('exams', function (Blueprint $table) {
            $table->foreign('exam_type_id')->references('id')->on('exam_types');
        });
        Schema::table('exams', function (Blueprint $table) {
            $table->foreign('result_type_id')->references('id')->on('result_types');
        });
        Schema::table('spermogrammes', function (Blueprint $table) {
            $table->foreign('antibiogramme_id')->references('id')->on('antibiogrammes');
        });
        Schema::table('prelevement_uretral_results', function (Blueprint $table) {
            $table->foreign('antibiogramme_id')->references('id')->on('antibiogrammes');
        });
        Schema::table('hemocultures', function (Blueprint $table) {
            $table->foreign('antibiogramme_id')->references('id')->on('antibiogrammes');
        });
        Schema::table('recherche_mycosplasmes', function (Blueprint $table) {
            $table->foreign('antibiogramme_id')->references('id')->on('antibiogrammes');
        });
        Schema::table('prelevement_cervico_vaginals', function (Blueprint $table) {
            $table->foreign('antibiogramme_id')->references('id')->on('antibiogrammes');
        });
        Schema::table('tests', function (Blueprint $table) {
            $table->foreign('exam_id')->references('id')->on('exams');
            $table->foreign('demand_id')->references('id')->on('demands');
            $table->foreign('insurance_id')->references('id')->on('insurances');
        });
        Schema::table('exam_price_by_insurance', function (Blueprint $table) {
            $table->foreign('exam_id')->references('id')->on('exams');
            $table->foreign('insurance_id')->references('id')->on('insurances');
        });
        Schema::table('insurance_to_patient', function (Blueprint $table) {
            $table->foreign('patient_id')->references('id')->on('patients');
            $table->foreign('insurance_id')->references('id')->on('insurances');
        });
        Schema::table('antibiogramme_result', function (Blueprint $table) {
            $table->foreign('antibiotique_id')->references('id')->on('antibiotiques');
            $table->foreign('antibiogramme_id')->references('id')->on('antibiogrammes');
        });
    }
    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('antibiogramme_result', function (Blueprint $table) {
            $table->dropForeign('antibiotique_id');
            $table->dropForeign('antibiogramme_id');
        });
        Schema::table('insurance_to_patient', function (Blueprint $table) {
            $table->dropForeign('patient_id');
            $table->dropForeign('insurance_id');
        });
        Schema::table('exam_price_by_insurance', function (Blueprint $table) {
            $table->dropForeign('exam_id');
            $table->dropForeign('insurance_id');
        });
        Schema::table('tests', function (Blueprint $table) {
            $table->dropForeign('exam_id');
            $table->dropForeign('demand_id');
            $table->dropForeign('insurance_id');
        });
        if (Schema::hasTable('prelevement_cervico_vaginals')) {
            Schema::table('prelevement_cervico_vaginals', function (Blueprint $table) {
                $table->dropForeign(['antibiogramme_id']);
            });
        }
        if (Schema::hasTable('recherche_mycosplasmes')) {
            Schema::table('recherche_mycosplasmes', function (Blueprint $table) {
                $table->dropForeign(['antibiogramme_id']);
            });
        }
        if (Schema::hasTable('hemocultures')) {
            Schema::table('hemocultures', function (Blueprint $table) {
                $table->dropForeign(['antibiogramme_id']);
            });
        }
        if (Schema::hasTable('prelevement_uretral_results')) {
            Schema::table('prelevement_uretral_results', function (Blueprint $table) {
                $table->dropForeign(['antibiogramme_id']);
            });
        }
        if (Schema::hasTable('spermogrammes')) {
            Schema::table('spermogrammes', function (Blueprint $table) {
                $table->dropForeign(['antibiogramme_id']);
            });
        }
        if (Schema::hasTable('exams')) {
            Schema::table('exams', function (Blueprint $table) {
                $table->dropForeign(['result_type_id']);
            });
        }
        if (Schema::hasTable('exams')) {
            Schema::table('exams', function (Blueprint $table) {
                $table->dropForeign(['exam_type_id']);
            });
        }
        if (Schema::hasTable('demands')) {
            Schema::table('demands', function (Blueprint $table) {
                $table->dropForeign(['qualification_id']);
            });
        }

        if (Schema::hasTable('demands')) {
            Schema::table('demands', function (Blueprint $table) {
                $table->dropForeign(['insurance_id']);
            });
        }
        if (Schema::hasTable('demands')) {
            Schema::table('demands', function (Blueprint $table) {
                $table->dropForeign(['patient_id']);
            });
        }
        Schema::dropIfExists('prelevement_cervico_vaginals');
        Schema::dropIfExists('recherche_mycosplasmes');
        Schema::dropIfExists('hemocultures');
        Schema::dropIfExists('prelevement_uretral_results');
        Schema::dropIfExists('spermogrammes');
        Schema::dropIfExists('antibiogramme_result');
        Schema::dropIfExists('antibiotiques');
        Schema::dropIfExists('antibiogrammes');
        Schema::dropIfExists('result_types');
        Schema::dropIfExists('exam_types');
        Schema::dropIfExists('insurance_to_patient');
        Schema::dropIfExists('numeric_results');
        Schema::dropIfExists('pn_results');
        Schema::dropIfExists('alpha_numeric_results');
        Schema::dropIfExists('exam_price_by_insurance');
        Schema::dropIfExists('qualifications');
        Schema::dropIfExists('tests');
        Schema::dropIfExists('hospitals');
        Schema::dropIfExists('exams');
        Schema::dropIfExists('demands');
        Schema::dropIfExists('insurances');
        Schema::dropIfExists('patients');
    }
}
